// Bs1ueb6.c -- Copyright 2005 by Matthias Jauernig
// Hauptprogramm mit Parentprozess
#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdbool.h>

int main(int argc, char **argv){
	int status1, status2, id1, id2;
	pid_t pid1, pid2;
	char *cargv1[4], *cargv2[4], *filename="child";
	
	// Argumentenlisten fr Childs fllen
	cargv1[0]=filename;
	cargv2[0]=filename;
	if(argc>1)
		cargv1[1]=argv[1];
	else{
		cargv1[1]=(char*)malloc(10);
		printf("Erste Zaehlzyklenzahl eingeben: ");
		scanf("%s",cargv1[1]);
	}
	if(argc>2)
		cargv2[1]=argv[2];
	else{
		cargv2[1]=(char*)malloc(10);
		printf("Zweite Zaehlzyklenzahl eingeben: ");
		scanf("%s",cargv2[1]);
	}
	cargv1[2]="1";
	cargv2[2]="2";
	cargv1[3]=NULL;
	cargv2[3]=NULL;
	
	// ersten Child erzeugen
	pid1 = fork();
	
	switch(pid1){
		case -1:
			perror("fork pid1");
			exit(1);
			break;
		case 0:
			// Child1 ausfhren
			execv(filename,cargv1);
			perror("Fehler bei Ausfhrung von Child1 in Parent");
			break;
		default:
			pid2 = fork();
			switch(pid2){
				case -1:
					perror("fork pid2");
					exit(1);
					break;
				case 0:
					// Child2 ausfhren
					execv(filename,cargv2);
					perror("Fehler bei Ausfhrung von Child2 in Parent");
					break;
				default:
					printf("Parent  -> Meine PID:  %d\n",(int)getpid());
					id1=0; id2=0;
					do{
						if(id1==0){
							id1=waitpid(pid1,&status1,WNOHANG);
							if(id1!=0)
								printf("Child1 beendet: PID=%d, Status: |%x|%x|\n",
									(int)pid1,(status1>>8)&0xFF,status1&0x7F);
						}
						if(id2==0){
							id2=waitpid(pid2,&status2,WNOHANG);
							if(id2!=0)
								printf("Child2 beendet: PID=%d, Status: |%d|%x|\n",
									(int)pid2,(status2>>8)&0xFF,status2&0x7F);
						}
					}while(!id1 || !id2);
					break;
			}
			break;
	}
	
	exit(1);
}
